%  de_current_to_best binomial
function y = currenttopbestbin_izrc(AR, P, F, CR, expt, a, b)
N = length(P(:, 1));
D = length(P(1, :)) - 1;

if isempty(AR)
    velarch = 0;
else
    velarch = length(AR(:, 1));
end

pmin = 2 / N;
p = round((pmin + (0.2 - pmin) * rand) * N);

pom = P;
sortrows(pom, D + 1);
pbest = pom(1:p, 1:D);
ktery = 1 + fix(p * rand(1));
xpbest = pbest(ktery, :);

xi = P(expt(1), 1:D);

vyb = nahvyb_expt(N, 1, expt);
r1 = P(vyb, 1:D);
expt = [expt, vyb];

vyb = nahvyb_expt(N + velarch, 1, expt);
sjed = [P(:, 1:D); AR];
r2 = sjed(vyb, :);

v = xi + F * (xpbest - xi) + F * (r1 - r2);
y = xi;
change = find(rand(1, D) < CR);
if isempty(change) % at least one element is changed
    change = 1 + fix(D * rand(1));
end
y(change) = v(change);

a = repmat(a, 1, D);
b = repmat(b, 1, D);

zrc=find(y<a|y>b);
for i=zrc
	while (y(i)<a(i)|y(i)>b(i))
		if y(i)>b(i)
		    y(i)=2*b(i)-y(i);
		elseif y(i)<a(i)
		    y(i)=2*a(i)-y(i);
		end
	end
end
